#!/usr/local/bin/ruby

include Math
require "Xeg"

def drawStar1(x, y, dx, dy, r, width, color)
  px = []
  py = []
#  print "x length: ", x.length, "  y length: ", y.length, "\n"
  for i in 1..x.length
	px.push(x[i-1] * r + dx)
	py.push(y[i-1] * r + dy)
  end
  $w.Polygon(px, py, width, Xeg::Gr_RGB, color)
end

def drawStar2(x, y, dx, dy, r, color)
  px = []
  py = []
#  print "x length: ", x.length, "  y length: ", y.length, "\n"
  for i in 1..x.length
	px.push(x[i-1] * r + dx)
	py.push(y[i-1] * r + dy)
  end
  $w.PolygonFill(px, py, Xeg::Gr_RGB, color)
end


x1 = 0; y1 = 0; x2 = 0; y2 = 0
buf = "ABCʣɣ123ܸijk#\@!"
kx  = [0.0, 5.0, 1.0, 2.0, 4.0]
ky  = [3.0, 4.0, 0.0, 5.0, 0.0]
$color = []

$w = Xeg::Image.new(100.0,100.0,500.0,500.0)

for j in 0..3
  if j == 0 then
	$color[0] = 1.0
  else
	$color[0] = 0.0
  end
  if j == 1 then
	$color[0] = 1.0
  else
	$color[0] = 0.0
  end
  if j == 2 then
	$color[0] = 1.0
  else
	$color[0] = 0.0
  end
  for i in 0..144
	$w.Line(x1, y1, x2, y2, 2.0, Xeg::Gr_RGB, $color)
	th = i * 3.1416 * 5 / 360.0
	x1 = 250.0 + 150.0 * ( 3 * sin(th) - 5 * cos(th) ) / sqrt(34.0)
	y1 = 250.0 + 150.0 * ( 3 * cos(th) - 5 * sin(th) ) / sqrt(34.0)
	x2 = 250.0 + 150.0 * ( 2 * sin(th) * sin(th) + 4 * sin(th) * cos(th) ) / sqrt(5.0)
	y2 = 250.0 + 150.0 * ( 2 * cos(th) * cos(th) + 4 * cos(th) * sin(th) ) / sqrt(5.0)
	$w.Line(x1, y1, x2, y2, 2.0, Xeg::Gr_RGB, $color)
  end
end

gets
$w.Clear

for i in 10..20
  $color[0] = i / 20.0
  $color[1] = 1.0 - i / 20.0
  $color[2] = 0.8
  $w.Arc(200.0, 250.0, i * 10, 100.0, 260.0, 2.0, Xeg::Gr_RGB, $color)
  $color[0] = 1.0 - i / 20.0
  $color[1] = 0.0
  $color[2] = i / 20.0
  $w.Arc(300.0, 250.0, i * 10, 280.0, 80.0, 2.0, Xeg::Gr_RGB, $color);
end
gets
$w.Clear

for i in 0..30
  $color = [i / 30.0, 1.0 - i / 30.0, 0.8]
  x = i * 10
  y = 130.0 + 50.0 * tan((i * 10 / 2.0 - 75.0) * 3.14 / 180.0)
  $w.Circle(x, y, i * 10 / 2.0, 3.0, Xeg::Gr_RGB, $color);
end
gets
$w.Clear

x1 = 0.0
while x1 <= 1.0
  $color[0] = x1
  x = 150.0 + x1 * 200.0
  x2 = 0.0
  while x2 <= 1.0
	$color[1] = x2
	$color[2] = 1.0 - x1 * x2
	y = 250.0 - x1 * 100.0 + x2 * 100.0
	$w.Fan(x, y, 200.0 - x2 * 200.0, 45.0, 135.0, 1.0, Xeg::Gr_RGB, $color)
	x2 += 0.02
  end
  x1 += 0.2
end
gets
$w.Clear

x1 = 0.0
while x1 <= 360.0
#  $color = [x1 / 360.0, 0.9, 1.0 - x1 / 360.0]
  $color[0] = x1 / 360.0
  $color[1] = 0.9
  $color[2] = 1.0 - x1 / 360.0
  r = 250.0 - x1 / 4.0
  $w.FanFill(250.0, 250.0, r, x1, x1 + 19.0, Xeg::Gr_RGB, $color)
  x1 += 20.0
end
gets
$w.Clear

i = 0
while i <= 400
  $color = [0.7, i / 400.0, 1.0 - i / 400.0]
  x = 150.0 + i / 4.0
  y = i + 20.0
  $w.Box(x, y, 250.0 - i / 2.0, 30.0, 5.0, Xeg::Gr_RGB, $color)
  i += 40
end
gets
$w.Clear

x1 = 0.0
while x1 < 1.0
  $color = [sin(x1 * 3.1416 / 2.0), cos(x1 * 3.1416 / 2.0), sqrt(x1)]
  x = 100.0 + x1 * 300.0
  y = 50.0
  $w.BoxFill(x, y, 30.0, 80.0, Xeg::Gr_MONO, $color)
  y = 150.0
  $w.BoxFill(x, y, 30.0, 80.0, Xeg::Gr_RGB, $color)
  y = 250.0
  $w.BoxFill(x, y, 30.0, 80.0, Xeg::Gr_MONO, $color)
  y = 350.0
  $w.BoxFill(x, y, 30.0, 80.0, Xeg::Gr_RGB, $color)
  x1 += 0.1
end
gets
$w.Clear

i = 0
while i <= 500
  j = 0
  while j <= 500
	$color = [i / 500.0, j / 500.0, 1.0 - i / 500.0]
	x = i
	y = j
	$w.CircleFill(x, y, 30.0, Xeg::Gr_RGB, $color)
	j += 50
  end
  i += 50
end
gets
$w.Clear

$color = [0.3, 0.5, 0.8]
drawStar1(kx, ky, 50.0,  200.0, 10.0, 2.0, $color)
drawStar1(kx, ky, 300.0, 250.0, 10.0, 2.0, $color)
drawStar1(kx, ky, 100.0, 50.0,  10.0, 2.0, $color)
drawStar1(kx, ky, 150.0, 300.0, 10.0, 2.0, $color)
drawStar1(kx, ky, 250.0, 50.0,  10.0, 2.0, $color)
$color = [1.0, 0.1, 0.1]
drawStar1(kx, ky, 50.0, 50.0, 60.0, 6.0, $color)
gets
$w.Clear

$color = [0.3, 0.5, 0.8]
drawStar2(kx, ky, 50.0,  200.0, 10.0, $color)
drawStar2(kx, ky, 300.0, 250.0, 10.0, $color)
drawStar2(kx, ky, 100.0, 50.0,  10.0, $color)
drawStar2(kx, ky, 150.0, 300.0, 10.0, $color)
drawStar2(kx, ky, 250.0, 50.0,  10.0, $color)
$color = [1.0, 0.1, 0.1]
drawStar2(kx, ky, 50.0, 50.0, 60.0, $color)
gets
$w.Clear

$color = [0.0, 0.8, 0.8]
$w.Text(50.0,  400.0, buf, Xeg::Gr_C,  18.0, Xeg::Gr_RGB, $color)
$w.Text(100.0, 375.0, buf, Xeg::Gr_CB, 18.0, Xeg::Gr_RGB, $color)
$w.Text(150.0, 350.0, buf, Xeg::Gr_CD, 18.0, Xeg::Gr_RGB, $color);
$w.Text(200.0, 325.0, buf, Xeg::Gr_CO, 18.0, Xeg::Gr_RGB, $color);
$w.Text(50.0,  300.0, buf, Xeg::Gr_H,  18.0, Xeg::Gr_RGB, $color);
$w.Text(100.0, 275.0, buf, Xeg::Gr_HB, 18.0, Xeg::Gr_RGB, $color);
$w.Text(150.0, 250.0, buf, Xeg::Gr_HD, 18.0, Xeg::Gr_RGB, $color);
$w.Text(200.0, 225.0, buf, Xeg::Gr_HO, 18.0, Xeg::Gr_RGB, $color);
$w.Text(50.0,  200.0, buf, Xeg::Gr_TB, 18.0, Xeg::Gr_RGB, $color);
$w.Text(100.0, 175.0, buf, Xeg::Gr_TD, 18.0, Xeg::Gr_RGB, $color);
$w.Text(150.0, 150.0, buf, Xeg::Gr_TI, 18.0, Xeg::Gr_RGB, $color);
$w.Text(200.0, 125.0, buf, Xeg::Gr_TR, 18.0, Xeg::Gr_RGB, $color);
$w.Text(50.0,  100.0, buf, Xeg::Gr_S,  18.0, Xeg::Gr_RGB, $color);
gets
$w.Clear
