#!/usr/local/bin/ruby

include Math
require "Xeg"

N = 200
R = 360.0
W = 200.0

circ  = [0.8, 0.5, 0.9]
gline = [0.3, 0.5, 0.0]
black = [0.0, 0.0, 0.0]

$cw = Xeg::Image.new(100.0, 280.0, R, R)
$gw = Xeg::Image.new(160.0, 20.0, 640.0, W)

def shot(n)
  h = 0
  blue = [0.0, 0.0, 1.0]
  red  = [1.0, 0.0, 0.0]

  for i in 0..n-1
	x = rand(32767).to_f / 32767
	y = rand(32767).to_f / 32767
	if (x * x + y * y) < 1.0
	  h += 1
	  c = blue
	else
	  c = red
	end
	$cw.CircleFill(x * R, y * R, 1.2, Xeg::Gr_RGB, c)
  end
  return h
end


$cw.CircleFill(0.0, 0.0, R, Xeg::Gr_RGB, circ)
$gw.Text(50.0, 20.0, "$B%b%s%F%+%k%mK!$K$h$k1_<~N($N6a;w(B",
		 Xeg::Gr_H, 28.0, Xeg::Gr_RGB, black)
$gw.Line(0.0, W / 2.0, 640.0, W / 2.0, 1.0, Xeg::Gr_MONO, black)
srand($$)
for i in 0..19
  rand(256)
end

total = N
hit = shot(total)
ratio = hit * 4.0 / N
x = (ratio - (PI - 0.125)) * 4 * W
y = 0.0
while y < 640
  hit += shot(N)
  total += N
  ratio = hit * 4.0 / total
  dx = (ratio - (PI - 0.125)) * 4 * W
  dy = y + 20.0
  printf "%f\n", ratio
#  print "hit:", hit, "  total:", total,
#	"  ratio:", ratio, "  dx:", dx, "dy: ", dy,
#	"  x:", x, "  y:", y, "\n"
  $gw.Line(y, x, dy, dx, 2.0, Xeg::Gr_RGB, gline)
  x = dx
  y = dy
end

gets
